<template>
  <a-modal
    centered
    class="chooseType-modal"
    :footer="null"
    :maskClosable="false"
    title="选择产品分类"
    v-model="isShow"
    @cancel="isShow=false"
    width="50%">
    <div class="chooseType-con">
      <a-tree
        style="height: 400px;overflow-y: scroll;"
        checkable
        @check="onCheck"
        :checkStrictly="linkageStatus"
        :checkedKeys="selectedKey"
        :treeData="productTypeList"
        :replaceFields="replaceFields"
        :expandedKeys.sync="expandedKeys"
      />
      <!-- 按钮 -->
      <div class="btn-con">
        <a-button
          id="chooseType-cancel"
          class="button-cancel"
          @click="isShow=false"
          style="padding: 0 30px;">取消</a-button>
        <a-button
          type="primary"
          id="chooseType-submit"
          @click="handleSave"
          style="padding: 0 30px;margin-left: 15px;">保存</a-button>
      </div>
    </div>
  </a-modal>
</template>

<script>
import { productTypeQuery } from '@/api/productType'
export default {
  name: 'ChooseTypeModal',
  props: {
    openModal: { //  弹框显示状态
      type: Boolean,
      default: false
    },
    chooseData: {
      type: Array,
      default: () => {
        return []
      }
    },
    linkageStatus: { // 父子是否联动
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      isShow: this.openModal, //  是否打开弹框
      selectedKey: [], //  选中项
      checkedRows: [], //  选中项  整条数据
      replaceFields: {// tree 渲染配置
        children: 'children',
        title: 'productTypeName',
        key: 'productTypeSn'
      },
      productTypeList: [], // tree列表数据
      expandedKeys: []// 第一级  展开sn
    }
  },
  methods: {
    //  产品分类  列表
    getProductType () {
      productTypeQuery({}).then(res => {
        if (res.status == 200) {
          this.recursionFun(res.data)
          this.productTypeList = res.data
          this.expandedKeys = this.getLevel1Keys(res.data) // 仅展开二级
        } else {
          this.productTypeList = []
        }
      })
    },
    // 遍历树数据，提取所有一级节点的 Key
    getLevel1Keys (treeData) {
      const keys = []
      treeData.forEach(level1Node => {
        keys.push(level1Node.productTypeSn)
      })
      return keys
    },
    // 保存
    handleSave () {
      if (this.selectedKey.checked && this.selectedKey.checked.length < 1) {
        this.$message.warning('请在列表勾选后再进行操作！')
        return
      }
      this.$emit('ok', this.checkedRows)
      this.isShow = false
    },
    //  递归函数
    recursionFun (data) {
      if (data) {
        data.map((item, index) => {
          item.disabled = (item.productTypeLevel == 1 || item.productTypeLevel == 3)
          if (item.children && item.children.length > 0) {
            this.recursionFun(item.children)
          }
        })
      }
    },
    onCheck (checkedKeys, { checkedNodes, node }) {
      this.checkedRows = []
      // 强制单选：仅保留最后一次选中的节点
      this.selectedKey = [node.eventKey]
      if (checkedNodes && checkedNodes.length == 1) {
        this.checkedRows.push(checkedNodes[0].data.props)
      } else {
        this.checkedRows.push(checkedNodes[1].data.props)
      }
    }
  },
  watch: {
    //  父页面传过来的弹框状态
    openModal (newValue, oldValue) {
      this.isShow = newValue
    },
    //  重定义的弹框状态
    isShow (newValue, oldValue) {
      if (!newValue) {
        this.$emit('close')
      } else {
        this.getProductType()
        // 清空已选项
        this.selectedKey = []
        // 回显已选数据
        const _this = this
        this.$nextTick(() => {
          _this.checkedRows = _this.chooseData
          _this.chooseData.forEach(item => {
            _this.selectedKey.push(item.goodsSn)
          })
        })
      }
    }

  }
}
</script>

<style lang="less" scoped>
  .chooseType-modal{
    .chooseType-con{
      .btn-con{
        text-align: center;
        margin: 30px 0 20px;
        .button-cancel{
          font-size: 12px;
        }
      }
    }
  }
</style>
